%define releasebase 2
#Use as deafults if no command line inputs
%define as_limulus 1
# define AFS defines here (only used if "--with afs" is given to rpmbuild):
%define afsarch amd
%define afsroot /afs/cad/hpc

# allow --with[out] <feature> at rpm command line build
%{?_with_basement: %{expand: %%define as_basement 1}}
%{?_with_limulus: %{expand: %%define as_limulus 1}}
%{?_with_afs: %{expand: %%define as_afs 1}}
#pick the target Limulus is default
%if "1" == "%{as_basement}"
%define targetbase Basement
%else
%if "1" == "%{as_afs}"
%define targetbase afs_%{afsarch}
%else
%define targetbase Limulus
%endif
%endif



%bcond_without  fedora
%define uid 43
%define username sgeadmin
%define instdir /opt
%define sharedir /usr/share
%define homedir %{instdir}/%{name}
%define _bindir %{homedir}/bin
%define _javadir %{sharedir}/java
%define _datadir %{homedir}/default
%define qmasterspool %{_datadir}/spool/sge_qmaster
%define execdspool %{_datadir}/spool/sge_execd
%define _libdir %{homedir}/lib
%define _mandir %{homedir}/man
%define utilbin %{homedir}/utilbin
Name:    gridengine
Version: 2011.11
Distribution: Scientific Linux
Release: %{releasebase}.%{targetbase}
Summary: Grid Engine - Distributed Computing Management software

Group:   %{targetbase}/Admin
# Only the file %{_libexecdir}/gridengine/bin/*/qmake is
# under GPLv2+, which is not used or linked by other parts
# of gridengine.
# The file %{_libexecdir}/gridengine/bin/*/qtcsh is
# under BSD with advertising, 
# which is not used or linked by other parts of gridengine.
License: (BSD and LGPLv2+ and MIT and SISSL) and GPLv2+ and BSD with advertising
URL:     http://gridscheduler.sourceforge.net
#This is make with maketarball <TAG>
%define  packagepath GE%{version}
Source0: GE2011.11.tar.gz
Source1: gridengine-ppc.tar.gz
Source2: my_configuration.conf
Source3: sge.csh
Source4: sge.sh
Source5: sge_execd
Source6: sgemaster
Source7: bootstrap
Source8: Licenses
Source9: gridengine.sysconfig
Source10: http://gridengine.sunsource.net/nonav/issues/showattachment.cgi/165/libcore.c
Source11: README
Source12: maketarball
Source13: sge-inst.conf
SOURCE14: host_alias_check.sh
Source15: new-sge-icons.tgz


# patches from Fedora build that seem to help the install
# Link ssl libraries dynamically so dependencies are pulled in
# http://gridengine.sunsource.net/issues/show_bug.cgi?id=2845
#Patch1: gridengine-6.2beta-ssl.patch
# Make inst_common.sh not look for qmon or sge_execd since they might not be installed
#Patch2: gridengine-6.2beta-inst.patch
# Don't need to make rc files in inst_common.sh
# Partially http://gridengine.sunsource.net/issues/show_bug.cgi?id=2780
#Patch3: gridengine-6.2u5-rctemplates.patch
# Fixup sge_ca to use system openssl and java paths
#Patch4: gridengine-6.2u2_1-sge_ca.patch
# Fixup jni paths
#Patch5: gridengine-6.2-jni.patch
# Use system db_ utils
#Patch6: gridengine-6.2-db.patch
# aimk sets -Werror, but there are lots of warnings
# http://gridengine.sunsource.net/issues/show_bug.cgi?id=2112
#Patch7: gridengine-6.2u2_1-Werror.patch
# Need to patch -Dant.library.dir=/usr/share/ant/lib to ant processes
# http://gridengine.sunsource.net/issues/show_bug.cgi?id=3171
#Patch8: gridengine-6.2u4-ant.patch
# Rename getline() to sge_getline()
# http://gridengine.sunsource.net/issues/show_bug.cgi?id=2980
#Patch9: gridengine-6.2u2_1-getline.patch
# Support lesstif - http://gridengine.sunsource.net/issues/show_bug.cgi?id=2310
#Patch15: gridengine-6.2beta2-lesstif.patch
# Make inst_sge exit with status 1 if usage is incorrect
# http://gridengine.sunsource.net/issues/show_bug.cgi?id=2586
#Patch19: gridengine-6.2u4-auto.patch
# Don't use rpaths
#Patch22: gridengine-6.2u2_1-rpath.patch
# Fix linking with proper libs
# http://gridengine.sunsource.net/issues/show_bug.cgi?id=2588
#Patch25: gridengine-6.2u2_1-libs.patch
# Handle ignoring return codes
#Patch26: gridengine-6.2beta2-error.patch
# Workaround for openssl-1.0 API change
#Patch27: gridengine-6.2u3-openssl.patch
# explicit addition of /usr/include/freetype2 path
#Patch28: gridengine-Xbae-freetype.patch
#Patch29: sge-passwd-buffer-overflow.patch  
#Patch30: sge-shepard-injection.patch

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires: /bin/csh, openssl-devel, db4-devel, db4-utils, ncurses-devel, pam-devel
BuildRequires: libXmu-devel, libXpm-devel, libXp-devel
#%if 0%{?rhel}
BuildRequires: openmotif-devel
#%else
#BuildRequires: lesstif-devel
#%endif
BuildRequires: java-devel >= 1.6.0, javacc, ant-junit, ant-nodeps
BuildRequires: elfutils-libelf-devel, net-tools
#BuildRequires: fedora-usermgmt-devel
Requires: binutils, db4-utils
Requires: ncurses
Requires(posttrans): /usr/sbin/alternatives
Requires(preun): /usr/sbin/alternatives
%{?FE_USERADD_REQ}


%description

Grid Engine (Open Grid Scheduler) finds a pool of idle resources and harnesses it
productively, so an organization gets as much as five to ten times the
usable power out of systems on the network. That can increase utilization
to as much as 98%.

Grid Engine software aggregates available compute resources and
delivers compute power as a network service.

These are the local files shared by both the qmaster and execd
daemons. You must install this package in order to use any one of them.


%package devel
Summary: Gridengine development files
Group: %{targetbase}/Admin
License: BSD and LGPLv2+ and MIT and SISSL
Requires: %{name} = %{version}-%{release}

%description devel
gridengine development headers and libraries.


%package qmon
Summary: Gridengine qmon monitor
Group: %{targetbase}/Admin
License: BSD and LGPLv2+ and MIT and SISSL
Requires: %{name} = %{version}-%{release}

%description qmon
The qmon graphical grid engine monitor


%package execd
Summary: Gridengine execd program
Group: %{targetbase}/Admin
License: BSD and LGPLv2+ and MIT and SISSL
Requires: %{name} = %{version}-%{release}
Requires(post): /sbin/chkconfig
Requires(postun): /sbin/service
Requires(postun): %{name} = %{version}-%{release}
Requires(preun): /sbin/chkconfig
Requires(preun): /sbin/service
Requires(preun): %{name} = %{version}-%{release}

%description execd
Programs needed to run a grid engine execution host. Can be installed
on the head node -- head node becomes an execution host. Assumes
NFS mount to SGE server.  Use execd-node for Warewulf clusters.

%package execd-node
Summary: Gridengine execd program
Group: %{targetbase}/Admin
License: BSD and LGPLv2+ and MIT and SISSL
Requires(post): /sbin/chkconfig
Requires(postun): /sbin/service
Requires(preun): /sbin/chkconfig
Requires(preun): /sbin/service

%description execd-node
Programs needed to run a grid engine execution host
on Warewulf cluster node. Assumes NFS mount to SGE server.

%prep
%setup -q -n GE2011.11 -a 1
#Copy Licenses and README file into build directory
cp %SOURCE8 %SOURCE11 .
#Remove unneeded shbangs
sed -i -e '/^#! *\/bin\/sh/d' source/dist/util/install_modules/*.sh
#%patch1 -p1 -b .ssl
#%patch2 -p1 -b .inst
#%patch3 -p1 -b .rctemplates
#%patch4 -p1 -b .sge_ca
#%patch5 -p1 -b .jni
#%patch6 -p1 -b .db
#%patch7 -p1 -b .Werror
#%patch8 -p1 -b .ant
##%patch9 -p1 -b .getline
##%if !0%{?rhel}
##%patch15 -p1 -b .lesstif
##%endif
#%patch19 -p1 -b .auto
#%patch22 -p1 -b .rpath
#%patch25 -p1 -b .libs
#%patch26 -p1 -b .error
#%patch27 -p1 -b .openssl
#%patch28 -p0
#%patch29 -p0
#%patch30 -p0
#sed -i.arch -e 's,/\$DSTARCH,,g' source/scripts/distinst
#Don't ship rctemplates
rm -rf source/dist/util/rctemplates
#Don't ship windows .bat scripts
find source -name \*.bat | xargs rm
#Fix permissions
#chmod +x source/dist/util/dl?.*sh 
#chmod -x source/dist/util/dl.*sh 
#find source -name \*.c | xargs chmod -x
#Fix flags for qmake build
#find source/3rdparty/qmake source/3rdparty/qtcsh -name Makefile | 
#  xargs sed -i -e "/^CFLAGS *=/s/=/= $RPM_OPT_FLAGS/"
#dlopen the runtime libssl library
#soname=$(objdump -p %{_libdir}/libssl.so | awk '/SONAME/ {print $2}')
#sed -i -e s/libssl\.so/$soname/ source/libs/comm/cl_ssl_framework.c
#Fix xterm path
#sed -i -e s,X11/xterm,xterm,g doc/htmlman/htmlman5/sge_conf.html \
#                              doc/man/man5/sge_conf.5 \
#                              source/dist/util/arch_variables \
#                              source/libs/sgeobj/sge_conf.c

# add new icons
#tar xvzf  %{SOURCE15}
%build
echo "Using  JAVADIR  = %{_javadir}"
export JAVA_HOME=%{java_home}
cd source
#Setup paths
cat > aimk.private <<EOF
set OPENSSL_HOME = /usr
set BERKELEYDB_HOME = /usr
set BDB_INCLUDE_SUBDIR = ../include
set BDB_LIB_SUBDIR = ../%{_lib}
set KRB_HOME = /usr
set MAN2HTMLPATH = /usr/bin
set GROFFPATH = /usr/bin
set SWIG = /usr/bin/swig
set PERL = /usr/bin/perl
set TCLSH = /usr/bin/tclsh
set JUNIT_JAR = /usr/share/java/junit.jar
set CORE_HOME = `pwd`
EOF
cat > build_private.properties <<EOF
javacc.home=%{_javadir}
libs.junit.classpath=%{_javadir}/junit.jar
izpack.lib=/usr/share/java/izpack
hadoop.javac.source=1.6
hadoop.javac.target=1.6
hadoop.home=/usr/share/java
EOF

#Build libcore.so
gcc $RPM_OPT_FLAGS -D_GNU_SOURCE -fPIC -c %SOURCE10 -o libcore.o
gcc $RPM_OPT_FLAGS -shared -o libcore.so libcore.o -lpthread
export SGE_INPUT_CFLAGS="$RPM_OPT_FLAGS"
touch aimk
./aimk -only-depend -no-secure
scripts/zerodepend
./aimk depend 
#TODO - Need IzPack for GUI Installer
./aimk -no-gui-inst -no-secure
./aimk -man -no-secure
#Not build by default - going to need hadoop
#ant herd


%install 
rm -rf $RPM_BUILD_ROOT
export SGE_ROOT=$RPM_BUILD_ROOT%{homedir}
mkdir -p $SGE_ROOT
export SGE_CELL=default
#Set the gridengine arch (assumes build host is same as execution host)
export GEARCH=`%{_builddir}/%{packagepath}/source/dist/util/arch`
pushd source

# install gridengine
echo "Y" | scripts/distinst -local -allall -nobdb -noopenssl -noexit $GEARCH
popd
# Move things to the right location for arch in the bin dir
#mkdir -p $RPM_BUILD_ROOT%{_bindir}/${GEARCH}
#mv $RPM_BUILD_ROOT%{_bindir}/q* $RPM_BUILD_ROOT%{_bindir}/${GEARCH}
#mv $RPM_BUILD_ROOT%{_bindir}/s* $RPM_BUILD_ROOT%{_bindir}/${GEARCH}
#  now do utilbin
#mkdir -p $RPM_BUILD_ROOT%{utilbin}/${GEARCH}
#pushd $RPM_BUILD_ROOT%{utilbin}
#FILELIST=`find . ! -name . -prune -type f`
#mv $FILELIST ${GEARCH}
#cd ${GEARCH}
## and now lib
#mkdir -p $RPM_BUILD_ROOT%{_libdir}/${GEARCH}
#mv $RPM_BUILD_ROOT%{_libdir}/lib* $RPM_BUILD_ROOT%{_libdir}/${GEARCH}
#popd
install -p -m755 source/libcore.so $RPM_BUILD_ROOT%{_libdir}/${GEARCH}
# put the java libs in the javadir
mkdir -p $RPM_BUILD_ROOT%{_javadir}
mv $RPM_BUILD_ROOT%{_libdir}/drmaa.jar $RPM_BUILD_ROOT%{_javadir}/drmaa.jar
mv $RPM_BUILD_ROOT%{_libdir}/JSV.jar $RPM_BUILD_ROOT%{_javadir}/JSV.jar
# fix the path in inst_qmaster.sh
/usr/bin/perl -pi -e "s!\$SGE_ROOT_VAL/bin!\$SGE_ROOT_VAL/bin/${GEARCH}!" $RPM_BUILD_ROOT/%{homedir}/util/install_modules/inst_qmaster.sh
#  use installscript, edit sge-inst.conf for your site
cp %{SOURCE13} .
pwd
/usr/bin/perl -pi -e "s!FILL-IN!$RPM_BUILD_ROOT/%{homedir}!" sge-inst.conf
pushd $SGE_ROOT
export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:$RPM_BUILD_ROOT%{_libdir}/${GEARCH}
echo $LD_LIBRARY_PATH
# inst_sge will attempt to start qmaster and write to /etc/sysconfig/gridengine
# these will be taken care of in a the post install
./inst_sge -m -x -auto %{_builddir}/%{packagepath}/sge-inst.conf || true

#Fix results of rpmbuilding in config files
SED_RULE="s!%{buildroot}/!!g"
/usr/bin/perl -pi -e $SED_RULE $SGE_ROOT/default/common/bootstrap
/usr/bin/perl -pi -e $SED_RULE $SGE_ROOT/default/common/configuration
#/usr/bin/perl -pi -e $SED_RULE $SGE_ROOT/default/common/settings.sh
#/usr/bin/perl -pi -e $SED_RULE $SGE_ROOT/default/common/settings.csh
/usr/bin/perl -pi -e "s!admin_user.*!admin_user\t\troot!" $SGE_ROOT/default/common/bootstrap
popd

#install -p -m644 %{SOURCE2} $RPM_BUILD_ROOT%{instdir}/gridengine
pushd source
install -p -m755 `scripts/compilearch -b`/qevent $RPM_BUILD_ROOT%{_bindir}/${GEARCH}
popd
# include links to the db utils
pushd $RPM_BUILD_ROOT%{utilbin}/${GEARCH}
DB_DUMP=`which db_dump`
ln -s $DB_DUMP db_dump
DB_LOAD=`which db_load`
ln -s $DB_DUMP db_load
popd
# app-defaults
mkdir -p $RPM_BUILD_ROOT%{sharedir}/X11/app-defaults
mv $RPM_BUILD_ROOT%{homedir}/qmon/*.ad \
   $RPM_BUILD_ROOT%{sharedir}/X11/app-defaults

#Install init.d scripts, provide "FILL-IN" information
install -d $RPM_BUILD_ROOT/etc/rc.d/init.d
cp %{SOURCE6} $SGE_ROOT/default/common/sgemaster
cp %{SOURCE5} $SGE_ROOT/default/common/sge_execd
SED_RULE="s!FILL-IN_BIN_PATH!%{_bindir}/${GEARCH}!g"
/usr/bin/perl -pi -e $SED_RULE $SGE_ROOT/default/common/sgemaster
/usr/bin/perl -pi -e $SED_RULE $SGE_ROOT/default/common/sge_execd
SED_RULE="s!FILL-IN_SGE_ROOT!%{homedir}!g"
/usr/bin/perl -pi -e $SED_RULE $SGE_ROOT/default/common/sgemaster
/usr/bin/perl -pi -e $SED_RULE $SGE_ROOT/default/common/sge_execd
SED_RULE="s!FILL-IN_UTILBIN!%{utilbin}/${GEARCH}!g"
/usr/bin/perl -pi -e $SED_RULE $SGE_ROOT/default/common/sgemaster
/usr/bin/perl -pi -e $SED_RULE $SGE_ROOT/default/common/sge_execd

mv $SGE_ROOT/default/common/sgemaster $RPM_BUILD_ROOT/etc/rc.d/init.d/sgemaster
ln -s /etc/rc.d/init.d/sgemaster $SGE_ROOT/default/common/sgemaster
mv $SGE_ROOT/default/common/sge_execd $RPM_BUILD_ROOT/etc/rc.d/init.d/sge_execd
ln -s /etc/rc.d/init.d/sge_execd $SGE_ROOT/default/common/sge_execd
chmod 755 $RPM_BUILD_ROOT/etc/rc.d/init.d/sgemaster $RPM_BUILD_ROOT/etc/rc.d/init.d/sge_execd

# set mangers and operators to sgeadmin
install -d $RPM_BUILD_ROOT%{execdspool}
#grep -v $LOGNAME $RPM_BUILD_ROOT%{qmasterspool}/managers > $RPM_BUILD_ROOT%{qmasterspool}/managers.new
#mv $RPM_BUILD_ROOT%{qmasterspool}/managers.new $RPM_BUILD_ROOT%{qmasterspool}/managers
#echo sgeadmin >> $RPM_BUILD_ROOT%{qmasterspool}/managers
#grep -v $LOGNAME $RPM_BUILD_ROOT%{qmasterspool}/operators > $RPM_BUILD_ROOT%{qmasterspool}/operators.new
#mv $RPM_BUILD_ROOT%{qmasterspool}/operators.new $RPM_BUILD_ROOT%{qmasterspool}/operators
#echo sgeadmin >> $RPM_BUILD_ROOT%{qmasterspool}/operators



mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig
cat <<EOF >$RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/gridengine
SGE_ROOT=%{homedir}
SGE_CELL=default
EOF

#sgeCA
mkdir -p $RPM_BUILD_ROOT%{_localstatedir}/sgeCA

# Don't package catman files
rm -rf $RPM_BUILD_ROOT%{homedir}/catman

#Don't need these
rm -rf $RPM_BUILD_ROOT%{homedir}/3rd_party
rm -rf $RPM_BUILD_ROOT%{homedir}/dtrace

#Don't ship example binaries
rm -rf $RPM_BUILD_ROOT%{homedir}/examples/jobsbin
rm -rf $RPM_BUILD_ROOT%{homedir}/examples/worker.*

#Cleanup some patch backups that get shipped
/bin/rm -f $RPM_BUILD_ROOT%{homedir}/util/install_modules/inst_*.sh.*
#Install log not needed 
rm -rf $RPM_BUILD_ROOT%{homedir}/default/common/install_logs
#TODO - Ship the GUI installer
rm $RPM_BUILD_ROOT%{homedir}/start_gui_installer
# set up configuration file
#allow users to delete their own jobs
sed -e 's!qmaster_params               none!qmaster_params               ENABLE_FORCED_QDEL!' $SGE_ROOT/default/common/configuration > $SGE_ROOT/default/common/configuration.new
mv $SGE_ROOT/default/common/configuration.new $SGE_ROOT/default/common/configuration
# set ssh paths
grep -v rsh_ $SGE_ROOT/default/common/configuration > $SGE_ROOT/default/common/configuration1
grep -v qlogin $SGE_ROOT/default/common/configuration1 > $SGE_ROOT/default/common/configuration2
grep -v rlogin $SGE_ROOT/default/common/configuration2 > $SGE_ROOT/default/common/configuration
rm $SGE_ROOT/default/common/configuration2 $SGE_ROOT/default/common/configuration1
cat << EOF >> $SGE_ROOT/default/common/configuration
qlogin_command               %{homedir}/util/qlogin_wrapper
qlogin_daemon                /usr/sbin/sshd -i
rlogin_command               /usr/bin/ssh
rlogin_daemon                /usr/sbin/sshd -i
rsh_command                  /usr/bin/ssh
rsh_daemon                   /usr/sbin/sshd -i
qrsh_command                 /usr/bin/ssh

EOF
# create /etc/ld.so.conf.d/
echo "Creating /etc/ld.so.conf.d/%{name}-${GEARCH} file"
mkdir -p $RPM_BUILD_ROOT/etc/ld.so.conf.d
cat <<EOF>> $RPM_BUILD_ROOT/etc/ld.so.conf.d/%{name}-${GEARCH}.conf
%{_libdir}/${GEARCH}
EOF
#Add host_alias_check.sh script
cp %{SOURCE14}  $RPM_BUILD_ROOT/%{homedir}/util


%clean
rm -rf $RPM_BUILD_ROOT


%pre
if grep sgeadmin /etc/passwd
then
        echo "SGE user already exists..."
else
        echo "Adding SGE user and group..."
        /usr/sbin/groupadd -g 888 sgeadmin
        /usr/sbin/useradd -u 888 -g 888 -r -c "Sun Grid Engine User"  -s /sbin/nologin sgeadmin
fi


%post
/sbin/ldconfig
#create the module file
echo "Creating module file"
cat <<EOF >/opt/Modules/modulefiles/sge6
#%Module1.0#######################################################################
## sge modulefile
##

proc ModulesHelp { } {
        puts stderr "\tThis module loads the appropriate environment for "
        puts stderr "\tusing %{name} Version %{version} \n"
}

module-whatis sge6
module-log error none

set currentmod \$env(HOME)/.currentmodules
set currentstring "module load sge6"
set sgeroot %{homedir}
set arch [ exec \$sgeroot/util/arch]

if [ module-info mode load ] {
        setenv SGE_ROOT \$sgeroot
        unsetenv SGE_CELL
        unsetenv COMMD_PORT
        append-path MANPATH \$sgeroot/man
        prepend-path PATH \$sgeroot/bin/\$arch
        append-path LD_LIBRARY_PATH \$sgeroot/lib/\$arch
}
if [ module-info mode remove ] {
        unsetenv SGE_ROOT
        remove-path MANPATH \$sgeroot/man
        remove-path PATH \$sgeroot/bin/\$arch
        remove-path LD_LIBRARY_PATH \$sgeroot/lib/\$arch
}
EOF
# set primary_qmaster, act_qmaster, and admin_host for this host
if [ "$1" = "1" ]; then
        HN=`hostname -s`
        FQHN=`%{homedir}/utilbin/linux-x64/gethostname -name`
        if [ "$HN" != "$FQDN" ];
        then
           echo "Setting $HN as alias for $FQHN in host_aliases"
				   echo "$HN $FQHN" >>%{homedir}/default/common/host_aliases
        fi
        echo "Using $HN for primary_qmaster, act_qmaster, and admin_host"
        echo $HN > %{homedir}/default/common/primary_qmaster
        echo $HN > %{homedir}/default/common/act_qmaster
        cat << EOF >> %{qmasterspool}/admin_hosts/$HN
# Version: 6.0
#
# DO NOT MODIFY THIS FILE MANUALLY!
#
hostname                   $HN
EOF
        cp %{qmasterspool}/admin_hosts/$HN %{qmasterspool}/submit_hosts/$HN
fi

# /configure /etc/services
echo "Adding sge_qmaster to /etc/services"
if grep "^sge_qmaster" /etc/services >/dev/null
then
        true
else
        echo "sge_qmaster          6444/tcp     # Sun Grid Engine Qmaster (Qmaster)" >>/etc/services
        echo "sge_qmaster          6444/udp     # Sun Grid Engine Qmaster (Qmaster)" >>/etc/services
fi
echo "Adding sge_execd to /etc/services"
if grep "^sge_execd" /etc/services >/dev/null
then
        true
else
        echo "sge_execd            6445/tcp     # Sun Grid Engine Execd (Qmaster)" >>/etc/services
        echo "sge_execd            6445/udp     # Sun Grid Engine Execd (Qmaster)" >>/etc/services
fi
#start qmaster at boot
echo "Setting sge_qmaster to start at boot levels 3 4 5"
/sbin/chkconfig --add sgemaster
/sbin/chkconfig --level 345 sgemaster on
# set up log rotation
cat <<EOF> /etc/logrotate.d/sge6
# Logrotate file for Gridengine logs
/opt/gridengine/default/spool/sge_qmaster/messages /opt/gridengine/default/spool/sge_execd/*/messages /opt/gridengine/default/common/accounting {
        missingok
        compress
        notifempty
        monthly
        rotate 12
        create 0600 root root
}
EOF

%preun
if [ $1 -eq 0 ]; then
    echo "Stoping qmaster"
    /sbin/service sgemaster stop
    /sbin/chkconfig --del sgemaster
fi

%postun 
if [ $1 -eq 0 ]; then
  echo "Removing %{name} ld.config.d file"
  /bin/rm /etc/ld.so.conf.d/%{name}*.conf
  echo "Removing module/logrotate config files"
  /bin/rm /opt/Modules/modulefiles/sge6
  /bin/rm -r /etc/logrotate.d/sge6

  if grep sgeadmin /etc/passwd
  then
          echo "Removing SGE user and group..."
          exec /usr/sbin/userdel sgeadmin
  fi
  if grep sgeadmin /etc/group
  then
          echo "SGE group still exists, it is now being removed..."
          exec /usr/sbin/groupdel sgeadmin
  fi
  echo "Removing qge_qmaster from /etc/services"
  grep -v "Sun Grid Engine Qmaster (Qmaster)" /etc/services >/tmp/services
  cat /tmp/services > /etc/services
  echo "Removing sge_execd from /etc/services"
  grep -v "Sun Grid Engine Execd (Qmaster)" /etc/services > /tmp/services
  cat /tmp/services > /etc/services
  rm -f /tmp/services
  /sbin/ldconfig
fi
if [ "$1" -ge "1" ]; then
        /sbin/service sgemaster condrestart >/dev/null 2>&1 || :
fi

%post execd
echo "Setting sge_exed to start at boot levels 3 4 5"
/sbin/chkconfig --add sge_execd
/sbin/chkconfig --level 345 sge_execd on
# Set up /etc/services
if grep "^sge_execd" /etc/services >/dev/null
then
        echo "sge_execd already in  /etc/services"
else
        echo "Adding sge_execd to /etc/services"
        echo "sge_execd            6445/tcp     # Sun Grid Engine Execd (Execd)" >>/etc/services
        echo "sge_execd            6445/udp     # Sun Grid Engine Execd (Execd)" >>/etc/services
fi
if grep "^sge_qmaster" /etc/services >/dev/null
then
        echo "sge_qmaster already in  /etc/services"
else
        echo "Adding sge_qmaster to /etc/services"
        echo "sge_qmaster          6444/tcp     # Sun Grid Engine Qmaster (Execd)" >>/etc/services
        echo "sge_qmaster          6444/udp     # Sun Grid Engine Qmaster (Execd)" >>/etc/services
fi
%post execd-node
# we do not start sge_execd at boot because
# NFS needs to be working. So to be sure we need to restart it in 
# /etc/rc.d/rc.local
# start it with
# /etc/rc.d/init.d/sge_execd restart
# 
#echo "Setting sge_exed to start at boot levels 3 4 5"
#/sbin/chkconfig --add sge_execd
#/sbin/chkconfig --level 345 sge_execd on

if grep 'sge_execd' /etc/rc.d/rc.local >/dev/null
then
  echo "sge_execd startup already in /etc/rc.d/rc.local"
else
  echo "Adding sge_execd to rc.local"
  echo "(There is a good reason for this)"
  cat <<EOF >>  /etc/rc.d/rc.local
# Added by Basement SGE install. Do not remove
%{homedir}/util/host_alias_check.sh
/etc/rc.d/init.d/sge_execd restart
EOF
fi
if grep "^sge_execd" /etc/services >/dev/null
then
        echo "sge_execd already in  /etc/services"
else
        echo "Adding sge_execd to /etc/services"
        echo "sge_execd            6445/tcp     # Sun Grid Engine Execd (Execd)" >>/etc/services
        echo "sge_execd            6445/udp     # Sun Grid Engine Execd (Execd)" >>/etc/services
fi
if grep "^sge_qmaster" /etc/services >/dev/null
then
        echo "sge_qmaster already in  /etc/services"
else
        echo "Adding sge_qmaster to /etc/services"
        echo "sge_qmaster          6444/tcp     # Sun Grid Engine Qmaster (Execd)" >>/etc/services
        echo "sge_qmaster          6444/udp     # Sun Grid Engine Qmaster (Execd)" >>/etc/services
fi


%postun execd-node
if [ "$1" -ge "1" ]; then
        /sbin/service sge_execd condrestart >/dev/null 2>&1 || :
fi
echo "Removing sge_execd from /etc/services"
grep -v "Sun Grid Engine Execd (Execd)" /etc/services > /tmp/services
cat /tmp/services > /etc/services
grep -v "Sun Grid Engine Qmaster (Execd)" /etc/services > /tmp/services
cat /tmp/services > /etc/services
rm -f /tmp/services
echo "Removing sge_execd startup from rc.local"
grep -v 'sge_execd' /etc/rc.d/rc.local >/tmp/rc.local
grep -v 'Added by Basement SGE install. Do not remove' /tmp/rc.local >/tmp/rc.local1
grep -v 'host_alias_check.sh' /tmp/rc.local1 >/tmp/rc.local2
cat /tmp/rc.local2 >/etc/rc.d/rc.local
rm -f /tmp/rc.local*


%postun execd
if [ "$1" -ge "1" ]; then
        /sbin/service sge_execd condrestart >/dev/null 2>&1 || :
fi
echo "Removing sge_execd from /etc/services"
grep -v "Sun Grid Engine Execd (Execd)" /etc/services > /tmp/services
cat /tmp/services > /etc/services
grep -v "Sun Grid Engine Qmaster (Execd)" /etc/services > /tmp/services
cat /tmp/services > /etc/services
rm -f /tmp/services
echo "Removing sge_execd startup from rc.local"
grep -v 'sge_execd' /etc/rc.d/rc.local >/tmp/rc.local
grep -v 'Added by SGE install. Do not remove' /tmp/rc.local >/tmp/rc.local1
grep -v 'host_alias_check.sh' /tmp/rc.local1 >/tmp/rc.local2
cat /tmp/rc.local2 >/etc/rc.d/rc.local
rm -f /tmp/rc.local*

%preun execd
if [ $1 -eq 0 ]; then
  if [ -e  %{homedir}/utilbin/linux-x64/gethostname ]; then
    echo "Stoping sge_execd"
    /sbin/service sge_execd stop
  fi
  /sbin/chkconfig --del sgemaster
fi

%files
%defattr(-,root,root,-)
%doc Licenses README
# % config(noreplace) %{_sysconfdir}/profile.d/sge.*
%config(noreplace) %{_sysconfdir}/sysconfig/gridengine
# Only the file %{_bindir}/qmake-ge is
# under GPLv2+
# Olny the file %{_bindir}/qtcsh is
# under BSD with advertising
%{_bindir}
%exclude %{_bindir}/linux*/qmon
%{_javadir}/drmaa.jar
%{_javadir}/JSV.jar
%{homedir}/doc
%{homedir}/hadoop
%{homedir}/inst_sge
%{homedir}/install_execd
%{homedir}/lib
%exclude %{_libdir}/linux*/libXltree.so
%{homedir}/ckpt
%{homedir}/examples/jobs
%{homedir}/mpi
%dir %{homedir}/pvm
%{homedir}/pvm/*
%exclude %{homedir}/pvm/src
%{homedir}/util
%dir %{homedir}/utilbin
%{homedir}/utilbin/*
%{_mandir}/man1/*.1*
%{_mandir}/man5/*.5*
%{_mandir}/man8/*.8*
%exclude %{_mandir}/man1/qmon.1*
%exclude %{_mandir}/man8/sge_execd.8*
%attr(-,%username,%username) %{_datadir}/common
%{_initrddir}/sgemaster
%{homedir}/install_qmaster
%attr(-,%username,%username) %dir %{_localstatedir}/sgeCA
%attr(-,%username,%username) %{_datadir}/spool
%{_sysconfdir}/ld.so.conf.d/gridengine*

%files devel
%defattr(-,root,root,-)
%{homedir}/include/*
%{_libdir}/linux*/libdrmaa.so
%{homedir}/examples/drmaa
%{homedir}/pvm/src
%{_mandir}/man3/*.3*

%files qmon
%defattr(-,root,root,-)
%{_bindir}/linux*/qmon
%{_libdir}/linux*/libXltree.so
%{sharedir}/X11/app-defaults/*
%{homedir}/qmon/
%{_mandir}/man1/qmon.1*

%files execd-node
%defattr(-,root,root,-)
%{_initrddir}/sge_execd
%{_sysconfdir}/ld.so.conf.d/gridengine*

%files execd
%defattr(-,root,root,-)
%{_initrddir}/sge_execd
%{_sysconfdir}/ld.so.conf.d/gridengine*


%changelog
* Mon Jun 11 2012 - Douglas Eadline <deadline@eadline.org>
- updated for OGS version 2011.11 
- added log rotation using logrotate
* Thu Oct 20 2011 - Douglas Eadline <deadline@eadline.org>
- added execd-node to make Warewulf installs easier
* Mon Jan 10 2011 - Douglas Eadline <deadline@eadline.org>
- added host_alias_check.sh and rc.local configs for nodes
- configured for integration with other tools
- added module file
* Tue Feb 16 2010 - Orion Poplawski <orion@cora.nwra.com> - 6.2u5-2
- Update ssl patch to add -lcrypt to fix FTBFS bug #565003

* Mon Dec 28 2009 - Orion Poplawski <orion@cora.nwra.com> - 6.2u5-1
- Update to 6.2u5

* Thu Oct 29 2009 - Orion Poplawski <orion@cora.nwra.com> - 6.2u4-1
- Update to 6.2u4
- Drop import patch fixed upstream
- Updated rctemplates and auto patches
- Add patch to call ant with appropriate library directory

* Tue Aug 25 2009 Tomas Mraz <tmraz@redhat.com> - 6.2u3-3
- rebuilt with new openssl

* Fri Jul 24 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 6.2u3-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Fri Jul 14 2009 - Orion Poplawski <orion@cora.nwra.com> - 6.2u3-1
- Update to 6.2u3
- Drop ppc patch fixed upstream
- Update rctemplates patch

* Mon Apr 6 2009 - Orion Poplawski <orion@cora.nwra.com> - 6.2u2_1-1
- Update to 6.2u2_1
- Rebase several patches
- Add patch to rename getline()
- Add patch to compile with correct libs on ppc/ppc64

* Tue Feb 24 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 6.2u1-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Thu Feb 19 2009 - Orion Poplawski <orion@cora.nwra.com> - 6.2u1-3
- Add patch to import specific classes to avoid pulling in other ones

* Thu Jan 15 2009 - Orion Poplawski <orion@cora.nwra.com> - 6.2u1-2
- Rebuild with openssl-0.9.8j

* Thu Dec 18 2008 - Orion Poplawski <orion@cora.nwra.com> - 6.2u1-1
- Update to 6.2u1

* Mon Nov 17 2008 - Orion Poplawski <orion@cora.nwra.com> - 6.2-5
- Leave qmake-ge in %{_bindir}
- Use system db_* utils in bdb_checkpoint script
- Fix xterm path in default setup
- Change java BR to >= 1.6.0 to allow building with other 1.6 javas

* Tue Nov 11 2008 - Orion Poplawski <orion@cora.nwra.com> - 6.2-4
- Add note to README about localhost line in /etc/hosts
- Cleanup setting.sh some, no more MAN stuff
- Add conditional build support for EL

* Wed Nov 5 2008 - Orion Poplawski <orion@cora.nwra.com> - 6.2-3
- Add Requires: ncurses for "clear"
- Add patch from CVS to update install scripts
- Patch sge_ca script not to use system openssl
- Modify code to dlopen runtime ssl library
- Patch install_qmaster to update /etc/sysconfig/gridengine
- Point install scripts to proper JAVA_HOME
- Have sgemaster init script use /etc/sysconfig/gridengine
- Add patch to point to jni library locations
- Make sure install_qmaster sets up default managers/operators

* Fri Sep 26 2008 - Orion Poplawski <orion@cora.nwra.com> - 6.2-2
- No more sge_schedd in 6.2, remove from startup script

* Mon Aug 11 2008 - Orion Poplawski <orion@cora.nwra.com> - 6.2-1
- Update to 6.2 final

* Tue Jul 15 2008 - Orion Poplawski <orion@cora.nwra.com> - 6.2beta2-0.1
- Provide some installation instructions for these RPMs
- Fix up some installation script issues
- Ghost more directories created later

* Thu Jun 5 2008 - Orion Poplawski <orion@cora.nwra.com> - 6.2beta-0
- Update to 6.2beta
- Use aimk.private and build_private.properties instead of patching
  aimk and build.properties
- Cleanup some extra /s in paths
- Shift to Java 1.6.0 because of new requirements in the source
- Move Java JNI libraries to proper location
- Drop several upstreamed patches
- Add patch to avoid linking unneeded libraries

* Fri Apr 11 2008 - Orion Poplawski <orion@cora.nwra.com> - 6.1u4-1
- Update to 6.1u4

* Tue Apr 1 2008 - Orion Poplawski <orion@cora.nwra.com> - 6.1u3-7
- Use alternatives to avoid conflicts with torque (bug #437613)
- Add patch to support stricter csh variable handling

* Fri Feb  8 2008 - Orion Poplawski <orion@cora.nwra.com> - 6.1u3-6
- Fixup subpackage License tags
- Service name change in scriptlets

* Thu Feb  7 2008 - Orion Poplawski <orion@cora.nwra.com> - 6.1u3-5
- Rewrite initscripts
- Remove spurious Requires(post): /sbin/ldconfig
- Add License explanation file and fix License tags

* Mon Feb  4 2008 - Orion Poplawski <orion@cora.nwra.com> - 6.1u3-4
- Drop arch from source
- Fix Requires() for main package
- Move man3 to -devel

* Fri Feb  1 2008 - Orion Poplawski <orion@cora.nwra.com> - 6.1u3-3
- Fix various review comments and rpmlint issues (bug #316141)

* Thu Jan 31 2008 - Orion Poplawski <orion@cora.nwra.com> - 6.1u3-2
- Actually ship sge_execd in the execd subpackage
- Don't complain about missing sge_execd during inst_sge -upd
- Link in db_dump and db_load into utilbin so that update scripts can find them

* Wed Jan  9 2008 - Orion Poplawski <orion@cora.nwra.com> - 6.1u3-1
- Update to 6.1u3
- Split execd into sub-package

* Thu Nov 15 2007 - Orion Poplawski <orion@cora.nwra.com> - 6.1u2-5
- Add BR net-tools for hostname for java build on devel

* Mon Nov 12 2007 - Orion Poplawski <orion@cora.nwra.com> - 6.1u2-4
- Add patch and source for ppc/ppc64 builds

* Fri Nov  1 2007 - Orion Poplawski <orion@cora.nwra.com> - 6.1u2-3
- Add patch to fix qstat xml output

* Thu Oct 18 2007 - Orion Poplawski <orion@cora.nwra.com> - 6.1u2-2
- Cleanup arch handling
- Install qevent

* Tue Oct  2 2007 - Orion Poplawski <orion@cora.nwra.com> - 6.1u2-1
- Fedora packaging
